Imports PCBI
Imports PCBI.Automation
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Windows.Forms

Namespace Demo4CSharp
	Public Class Form1
		Inherits Form

		Private window As IPCBIWindow

		Private [step] As IStep

		Private components As IContainer = Nothing

		Private WithEvents button1 As Button

		Private textBox1 As TextBox

		Public Sub New()
			Me.InitializeComponent()
			IAutomation.IAutomationInit()
		End Sub

		Friend Sub CreateLine(pcbiFilter As IFilter, matrix As IMatrix, parentLayer As IODBLayer, lineStart As PointF, lineEnd As PointF, thickness As Single, NetName As String, [step] As IStep)
			Dim line As IODBObject = pcbiFilter.CreateLine(parentLayer)
			Dim specLine As ILineSpecifics = CType(line.GetSpecifics(), ILineSpecifics)
			specLine.Start = lineStart
			specLine.[End] = lineEnd
			specLine.ShapeIndex = Form1.CheckShapeIndexRound(pcbiFilter, parentLayer, thickness)
			specLine.Diameter = CDec(thickness)
            specLine.Positive = True
			specLine.Type = Symbol_Type.r
			line.SetSpecifics(specLine, specLine.ShapeIndex)
		End Sub

        Private Sub buttonAddLineAndLayerToExistingStep_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
            If Me.window Is Nothing Then
                Me.window = IAutomation.CreateNewPCBIWindow(True)
            End If
            Me.window.LoadODBJob(Me.textBox1.Text)
            Me.[step] = Me.window.GetCurrentStep()
            If Me.[step] Is Nothing Then
                Console.WriteLine("error: no job loaded!")
            Else
                Dim filter As IFilter = New IFilter(Me.window)
                Dim layer As IODBLayer = filter.CreateEmptyODBLayer("layer1", Me.[step].Name)
                Me.CreateLine(filter, Me.window.GetMatrix(), layer, New PointF(10.0F, 10.0F), New PointF(150.0F, 10.0F), 10.0F, "", Me.[step])
                Dim matrix As IMatrix = Me.window.GetMatrix()
                If matrix IsNot Nothing Then
                    matrix.UpdateDataAndList()
                End If
            End If
        End Sub

		Friend Shared Function CheckShapeIndexRound(pcbiFilter As IFilter, parentLayer As IODBLayer, diameter As Single) As Integer
			Dim symbolList As Dictionary(Of Integer, IFilter.ToolDefinition) = pcbiFilter.GetUsedSymbolList(parentLayer)
			Dim result As Integer
			For Each symbs As KeyValuePair(Of Integer, IFilter.ToolDefinition)In symbolList
				If symbs.Value.Diameter = CDec(diameter) AndAlso symbs.Value.Type = Symbol_Type.r Then
					result = symbs.Key
					Return result
				End If
			Next
			Dim shapeIndex As Integer = IFilter.AddToolDefinitionRound(parentLayer, diameter, 1)
			result = shapeIndex
			Return result
		End Function

        Protected Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso Me.components IsNot Nothing Then
                Me.components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private Sub InitializeComponent()
            Me.button1 = New Button()
            Me.textBox1 = New TextBox()
            MyBase.SuspendLayout()
            Me.button1.Location = New Point(12, 54)
            Me.button1.Name = "button1"
            Me.button1.Size = New Size(260, 74)
            Me.button1.TabIndex = 0
            Me.button1.Text = "Demo 4: Create Line on new layer"
            Me.button1.UseVisualStyleBackColor = True
            Me.textBox1.Location = New Point(12, 12)
            Me.textBox1.Name = "textBox1"
            Me.textBox1.Size = New Size(260, 20)
            Me.textBox1.TabIndex = 1
            Me.textBox1.Text = "Insert Path of ODB++ Job"
            MyBase.AutoScaleDimensions = New SizeF(6.0F, 13.0F)
            MyBase.AutoScaleMode = AutoScaleMode.Font
            MyBase.ClientSize = New Size(284, 140)
            MyBase.Controls.Add(Me.textBox1)
            MyBase.Controls.Add(Me.button1)
            MyBase.Name = "Form1"
            Me.Text = "Demo 4"
            MyBase.ResumeLayout(False)
            MyBase.PerformLayout()
        End Sub
    End Class
End Namespace
